'                 Mosby Null Test grating generator.
' Approach derived from "Optical Shop Testing"  ISBN 0-471-01973-9
' Mobsby code author Anthony Stillman copywrite 1999
' .bmp save subroutines derived from work by  Carlos E. Diaz, Jr.
'             Use this program at your own risk!
' The author is NOT liable for ANY damage it may cause.
' This software may be used freely for non-commertial purposes
' This software may not be sold or included for sale in any package
' If you have a commertial purpose, please contact me for use permissions
' Original obtained from post by Anthony Stillman on Oct. 99 to the ATM list.
' Modified by Bob May to be used for general purpose Mosby Null generation
' starting 2/8/2001.  The program was rife with errors when obtained.

DECLARE SUB printparams ()
DECLARE SUB printmenu ()
DECLARE SUB getvalues ()
DECLARE SUB notes ()
DECLARE SUB helpit ()
DECLARE SUB calculate ()
DECLARE SUB MakeBMP ()
DECLARE SUB BMPheader ()

DIM SHARED afew AS INTEGER   'length of distance ticks
DIM SHARED Asu AS INTEGER
DIM SHARED Bs AS INTEGER
DIM SHARED Cs AS INTEGER
DIM SHARED fcnt AS INTEGER   'Number of fringes to do
DIM SHARED fr2 AS INTEGER    '
DIM SHARED m AS INTEGER      'fringe order
DIM SHARED pf AS INTEGER     'Previous flag
DIM SHARED xcen AS INTEGER   'X center of screen
DIM SHARED xbot AS INTEGER   'X bottom of screen
DIM SHARED Xs AS INTEGER
DIM SHARED ycen AS INTEGER   'Y center of screen
DIM SHARED ybot AS INTEGER   'Y bottom of screen
DIM SHARED Ys AS INTEGER

DIM SHARED d AS SINGLE       'Diameter of the mirror
DIM SHARED dr AS SINGLE      'Distance of grating from focus
DIM SHARED dx AS SINGLE      'Distance of a fringe
DIM SHARED eyeref AS SINGLE  '
DIM SHARED fl AS SINGLE      'focal length
DIM SHARED fr AS SINGLE      'focal ratio
DIM SHARED K AS SINGLE       '- Schwartzchild constant
DIM SHARED p2 AS SINGLE      'delta p squared p is point on a fringe
DIM SHARED pU AS SINGLE      'previous U
DIM SHARED pV AS SINGLE      'previous V
DIM SHARED R AS SINGLE       'Radius of curvature
DIM SHARED r2max AS SINGLE   'radius of drawn point on the fringe squared.
DIM SHARED rmax AS SINGLE    'radius of surface
DIM SHARED scale AS SINGLE   'Scaling factor for the screen
DIM SHARED scaleref AS SINGLE   'Ref. Scaling factor for the screen
DIM SHARED U AS SINGLE       'drawing position on screen for X
DIM SHARED V AS SINGLE       'drawing position on screen for Y
DIM SHARED X AS SINGLE       'X coordinate of the point on the fringe
DIM SHARED x2 AS SINGLE      'X coordinate squared of the point on the fringe
DIM SHARED xinc AS SINGLE    'Plotting granulation for x increment
DIM SHARED Xmin AS SINGLE    '
DIM SHARED Y AS SINGLE       'Y position of point on the fringe

DIM Filelen AS LONG

DIM SHARED file1 AS STRING
DIM SHARED file2 AS STRING
DIM SHARED varib AS STRING
DIM SHARED buffer AS STRING
DIM SHARED Hd AS STRING
DIM SHARED Xsu(51) AS SINGLE:   ' Array of minimum x values, 25 fringes is way too many

'                 Graphics variables
xcen = 370:   ' Screen x-center
ycen = 240:   ' Screen y-center
xbot = 580:   ' Positions scale line at right of screen
ybot = 450:   ' Positions scale line at bottom of screen
afew = 6:     ' Length of distance ticks
scaleref = 200:  ' Screen scaling value

'                  Initialization block
SCREEN 12:    ' Activate 640 X 480 VGA screen
COLOR 7
'             User selectable values
xinc = -.000001: ' Plotting granulation, between -0.01 and -0.0001
d = 12.5:     ' Mirror diameter    12.5
fr = 13.6:    ' Mirror focal ratio 3.6
dr = 2        ' Distance from paraxial focus to grating, must be 0 or positive .27
eyeref = 4    ' Distance from your eye/camera to the grating 3
K = 1         ' Conic constant     1
fcnt = 5      'fringe count for inputting purposes.  9
fcnt = fcnt \ 2       'these two lines makes the count odd
fcnt = fcnt * 2 + 1
getvalues
CLS
printparams

' Grating Calculation block
calculate
  ' Bigin bit map (.bmp) save block
IF (file1 <> "") THEN
  MakeBMP
END IF
printmenu
DO
  varib = INKEY$
  file2 = ""
  SELECT CASE UCASE$(varib)
    CASE "R"
      CLS
      getvalues
      CLS
      calculate
      printparams
      printmenu
    CASE "C"
      CLS
      calculate
      printparams
      printmenu
    CASE "S"
      DO WHILE file2 = ""
        LOCATE 28, 3: INPUT "File name please"; file2
      LOOP
      OPEN file2 FOR RANDOM AS #1
      PUT #1, , d
      PUT #1, , fr
      PUT #1, , dr
      PUT #1, , eyeref
      PUT #1, , K
      PUT #1, , fcnt
      CLOSE #1
    CASE "B"
      MakeBMP
    CASE "H"
      helpit
    CASE "Q"
      varib = "Q"
    CASE "N"
      notes
    CASE ELSE
  END SELECT
LOOP WHILE varib <> "Q"
LOCATE 28, 5: PRINT "*** Program Complete ***"


END

SUB BMPheader
    Hd = CHR$(66) + CHR$(77) + CHR$(118) + CHR$(88) + CHR$(2) + CHR$(0) + CHR$(0) + CHR$(0)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(118) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(40) + CHR$(0)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(128) + CHR$(2) + CHR$(0) + CHR$(0) + CHR$(224)
    Hd = Hd + CHR$(1) + CHR$(0) + CHR$(0) + CHR$(1) + CHR$(0) + CHR$(4) + CHR$(0) + CHR$(0)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(128)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(128) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(128) + CHR$(128)
    Hd = Hd + CHR$(0) + CHR$(128) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(128) + CHR$(0)
    Hd = Hd + CHR$(128) + CHR$(0) + CHR$(128) + CHR$(128) + CHR$(0) + CHR$(0) + CHR$(128)
    Hd = Hd + CHR$(128) + CHR$(128) + CHR$(0) + CHR$(192) + CHR$(192) + CHR$(192)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(255) + CHR$(0) + CHR$(0) + CHR$(255)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(255) + CHR$(255) + CHR$(0) + CHR$(255)
    Hd = Hd + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(255) + CHR$(0) + CHR$(255) + CHR$(0)
    Hd = Hd + CHR$(255) + CHR$(255) + CHR$(0) + CHR$(0) + CHR$(255) + CHR$(255) + CHR$(255)
    Hd = Hd + CHR$(0)
END SUB

SUB calculate           'calculate the grating
'there's an error in the line drawing routine that allows for a gap in the line
COLOR 15
FOR m = 1 TO (fcnt + 1) STEP 1     'generate the count of fringes
  fr2 = 0                   'fringe #
  p2 = 0                    'start the drawing point at 0
  bob = 0
'          SC * Fringe# ^3 * delta X ^3     Fringe# * delta X * dist. from focus
'Xmin = -  ----------------------------  -  --------------------------------
'                   Radius ^2                          Radius
  Xmin = -((K * m ^ 3 * dx ^ 3) / (R ^ 2)) - (m * dx * dr) / R
  X = Xmin
  Xsu(m) = X: ' Save the start point of the curve
  WHILE (p2 < r2max)        'do a pair of lines 1+, 1- on horiz dim.
'             ROC of mirror ^2 * Xpos ^3      ROC * dist. from focus * Xpos^2
' Psquared =  ---------------------------  -  ------------------------------
'            SC * Fringe# ^3 * Delta X ^3      SC * fringe# ^2 * Delta x ^2
    p2 = -((R ^ 2 * X ^ 3) / (K * m ^ 3 * dx ^ 3)) - ((R * dr * X ^ 2) / (K * m ^ 2 * dx ^ 2))
    x2 = X ^ 2
    IF (x2 >= p2) THEN    'we're starting a line
      Y = 0               'so restart the Y dir.
    ELSE
      Y = SQR(p2 - x2)    'get the rest of the triangle
    END IF
    U = (X * scale) \ 1     'scale the X and Y values
    V = (Y * scale) \ 1
    IF (pf = 0) THEN      'we didn't have a line started
      pU = U
      pV = V
      pf = 1
    END IF
    IF ABS(pU) > rmax THEN
      IF U > 0 THEN
        U = rmax
        pU = rmax
      END IF
      IF U < 0 THEN
        U = -rmax
        pU = -rmax
      END IF
    END IF
    LINE (pU \ 1 + xcen, pV \ 1 + ycen)-(U \ 1 + xcen, V \ 1 + ycen + 1)
    LINE (-pU \ 1 + xcen, -pV \ 1 + ycen)-(-U \ 1 + xcen, -V \ 1 + ycen - 1)
    LINE (pU \ 1 + xcen, -pV \ 1 + ycen)-(U \ 1 + xcen, -V \ 1 + ycen + 1)
    LINE (-pU \ 1 + xcen, pV \ 1 + ycen)-(-U \ 1 + xcen, V \ 1 + ycen - 1)
    pU = U
    pV = V
    X = X + xinc
  WEND          'finish up the line pair
  pf = 0
NEXT m          'finish up the number of lines to draw
' Fill blockREM  Circle then, fill every other fringe
'  Draw scale marks
CIRCLE (xcen, ycen), rmax                     'draw the circle
LINE (xcen, ycen + rmax)-(xcen, ycen - rmax)  'draw the midline
alt = 1
Xsu(fcnt + 2) = -SQR(r2max)
FOR N = 1 TO fcnt + 1         'fill in the stripes
  px = scale * (Xsu(N) + Xsu(N + 1)) / 2      'get the midpoint between
  IF N = 1 THEN PAINT (xcen - px / 2, ycen)
  IF alt > 0 THEN
    px = xcen + px - 1          'make sure that we don't mark outside the
    IF px <= xcen - 200 THEN    'circle or we fill in everything
      px = xcen - 199
      N = fcnt + 1
    END IF
    PAINT (px, ycen)
  ELSE
    px = xcen - px + 1
    IF px >= xcen + 200 THEN px = xcen + 199
    PAINT (px, ycen)
  END IF
  alt = -alt
NEXT N
'                 Distance ticks
LINE (xcen - rmax, ybot)-(xcen + rmax, ybot)
'LINE (xbot, ycen - rmax)-(xbot, ycen + rmax)
LINE (xcen - rmax, ybot + afew)-(xcen - rmax, ybot - rmax + afew * 8)
LINE (xcen + rmax, ybot + afew)-(xcen + rmax, ybot - rmax + afew * 8)
LINE (xcen - rmax, ybot)-(xcen - rmax + afew, ybot + afew)
LINE (xcen - rmax, ybot)-(xcen - rmax + afew, ybot - afew)
LINE (xcen + rmax, ybot)-(xcen + rmax - afew, ybot + afew)
LINE (xcen + rmax, ybot)-(xcen + rmax - afew, ybot - afew)
'LINE (xbot, ycen - rmax)-(xbot + afew, ycen - rmax)
'LINE (xbot, ycen + rmax)-(xbot + afew, ycen + rmax)

LOCATE 29, 36: PRINT INT(100 * SQR(r2max)) / 100; " Dia.";
COLOR 7

END SUB

SUB getvalues

varib = ""
LOCATE 4, 16: PRINT "Welcome to the Mosby Null Test Pattern Generator"
LOCATE 7, 7: PRINT "You can save to a file once you have a design into the program."
LOCATE 8, 4: PRINT "Please remember the name that you give the design for future reference."
LOCATE 12, 12: INPUT "Enter by File or Keyboard - F or K"; varib
IF UCASE$(varib) = "K" THEN
  LOCATE 10, 12: PRINT "                                              "
  LOCATE 14, 12: INPUT "Diameter of the Mirror"; d
  LOCATE 15, 12: INPUT "Focal Ratio of Mirror"; fr
  LOCATE 16, 12: INPUT "Distance from Paraxial (center) focus to the grating"; dr
  LOCATE 17, 12: INPUT "Distance from the grating to your eye"; eyeref
  DO
    LOCATE 18, 12: INPUT "Conic Constant  Parabola = -1"; K
    IF K >= 0 THEN
      COLOR 11: LOCATE 19, 12: PRINT "A value of 0 for the Conic Constant will not work!"
      COLOR 7
    END IF
  LOOP WHILE K >= 0
  K = -K        'convert to the way the program needs.
  LOCATE 19, 12: PRINT "                                                  "
  LOCATE 20, 12: PRINT "The actual number of fringes will always be odd."
  DO
    LOCATE 19, 12: INPUT "Number of fringes desired"; fcnt
  LOOP WHILE fcnt > 20 OR fcnt < 3
ELSEIF UCASE$(varib) = "F" THEN
  LOCATE 10, 12: PRINT "                                     "
  DO
    temp = 0
    LOCATE 14, 32: PRINT "            "
    LOCATE 14, 12: INPUT "File name of the values"; file2
    IF LEN(file2) > 8 THEN
      temp = 1
      IF LEN(file2) < 13 THEN
        IF INSTR(file2, ".") < 10 THEN temp = 0
      END IF
    END IF
    IF temp = 1 THEN LOCATE 12, 9: PRINT "Not a valid filename - filelengths are wrong."
    IF LEFT$(file2, 1) = "." THEN temp = 1
    IF temp = 0 THEN
      OPEN file2 FOR BINARY ACCESS WRITE AS #1
      Filelen = LOF(1)
      CLOSE #1
      IF Filelen = 0 THEN
        temp = 1
        LOCATE 16, 9: PRINT "Not a valid filename - file does not exist."
      END IF
    END IF
  LOOP WHILE temp = 1
    OPEN file2 FOR RANDOM AS #1
    GET #1, , d
    GET #1, , fr
    GET #1, , dr
    GET #1, , eyeref
    GET #1, , K
    GET #1, , fcnt
    CLOSE #1
ELSE varib = ""
END IF
'             Calculation start
fl = d * fr   'get focal length
R = 2 * fl    'get radius of curvature
dx = d / fcnt 'get distance of a fringe
pf = 0        'Previous flag, used in rendering
r2max = ((eyeref * d) / (eyeref + R)) ^ 2: ' The size of the grating squared
scale = scaleref / SQR(r2max)
rmax = scale * SQR(r2max)

END SUB

SUB helpit    'print a help note.

CLS
COLOR 6
LOCATE 3, 20: PRINT "Help on the program"
COLOR 7
LOCATE 5, 7: PRINT "Enter valid values for the scope's parameters and enter how far you"
LOCATE 6, 4: PRINT "want the grating to be inside the focus point of the center part of the"
LOCATE 7, 4: PRINT "mirror.  The eye position will be at some distance behind the grating "
LOCATE 8, 4: PRINT "and that distance will affect the appearance of the lines in the grating."
LOCATE 9, 4: PRINT "If the lines don't fill the grating width as you desire, decrease the"
LOCATE 10, 4: PRINT "distance to the eye from the grating.  Other option is to increase the"
LOCATE 11, 4: PRINT "distance of the grating from the focus or decrease the number of lines."
LOCATE 12, 4: PRINT ""
LOCATE 13, 4: PRINT "The number of lines in the grating will always be odd with the center"
LOCATE 14, 4: PRINT "left line being black.  "
LOCATE 15, 4: PRINT "Lines outside of the circle are normal due to the design presently."
LOCATE 16, 4: PRINT "The lines are the artifact of drawing the edge of the Ronchi line."
LOCATE 20, 4: PRINT "Press C to redisplay the image or Q to quit."
END SUB

SUB MakeBMP              'make the file

DIM Header AS STRING
'======== Set File name from this line ======
CLS
file1 = ""
LOCATE 11, 11: PRINT "Please enter a file name for the resulting bit map"
LOCATE 12, 11: PRINT "To skip saving, press Enter with no filename entry"
DO
  temp = 0      'indication that things are bad
  LOCATE 13, 45: PRINT "                        "
  LOCATE 13, 10: INPUT "The .bmp extension will be added by the program  ", file1
  LOCATE 20, 11: PRINT "                                                              "
  LOCATE 21, 11: PRINT "                                                        "
  temp = INSTR(file1, ".")
  IF temp <> 0 THEN
    temp = 0
    LOCATE 20, 11: PRINT "Filename is not valid.  Do not enter '.' in the filename."
    LOCATE 21, 11: PRINT "The program will add the .BMP extension to the filename."
  ELSE temp = 2
  END IF
  IF LEFT$(file1, 1) = "." THEN temp = 0
  IF LEN(file1) > 8 THEN
    LOCATE 20, 11: PRINT "Filename length is longer than 8 characters.  Please do again."
    temp = 0
  END IF
LOOP WHILE temp = 0 OR temp = 1
'scan filename for . and reject if there
file1 = file1 + ".bmp"
CLS
calculate
printparams
WINDOW SCREEN (0, 479)-(639, 0)
BMPheader
IF file1 <> ".bmp" THEN
  OPEN file1 FOR BINARY ACCESS WRITE AS #1
  Filelen = LOF(1)
  CLOSE #1
  IF Filelen = 0 THEN
    OPEN file1 FOR BINARY ACCESS WRITE AS #1
    PUT #1, , Hd                    'write the header out
    FOR Ys = 479 TO 0 STEP -1       'each line
      FOR Xs = 0 TO 639 STEP 2      'each pixel
        Asu = POINT(Xs, Ys)         'get the left pixel
        Bs = POINT(Xs + 1, Ys)      'get the right pixel
        Cs = Asu * 16 + Bs          'put them together
        buffer = buffer + CHR$(Cs)  'and add to the buffer
      NEXT Xs
      PUT #1, , buffer              'put the buffer out to the file
      buffer = ""                   'and empty it
      LINE (627, Ys)-(629, Ys), 3   'progress indicator
    NEXT Ys
    CLOSE #1
    LOCATE 28, 5: PRINT "*** File saved ***"
  ELSE
    LOCATE 7, 2: PRINT "Attention! I cannot make"
    LOCATE 8, 2: PRINT "the file " + CHR$(34) + file1 + CHR$(34) + "!"
    LOCATE 9, 2: PRINT "That filename already"
    LOCATE 10, 2: PRINT "exists and this"
    LOCATE 11, 2: PRINT "program will NOT"
    LOCATE 12, 2: PRINT "write over another"
    LOCATE 13, 2: PRINT "file!"
  END IF
END IF
printmenu
  
END SUB

SUB notes       'print a set of notes.
CLS
LOCATE 3, 20: PRINT "Notes on the Mosby Null program                 Ver. 1.00"
LOCATE 5, 7: PRINT "This program was derived from the formulas on page 296 in the book"
LOCATE 6, 4: PRINT "'Optical Shop Testing'   ISBN 0-471-01973-9 and the original code for"
LOCATE 7, 4: PRINT "this program was done by Anthony Stillman copywrited 1999 with the BMP "
LOCATE 8, 4: PRINT "routine by Carlos E. Diaz, Jr.     Please note that as with any sofware,"
LOCATE 9, 4: PRINT "you, not the authors, are responsible for ANY damage that this program may"
LOCATE 10, 4: PRINT "cause.  Software may not be used for commercial purposes of any kind and if"
LOCATE 11, 4: PRINT "you have a commercial use contact Anthony Stillman for permissions requred."
LOCATE 12, 4: PRINT "Program has been modified from the Anthony Stillman code by Bob May in 2001"
LOCATE 13, 4: PRINT "to make a more useful program.  The code does the formulas as best known"
LOCATE 14, 4: PRINT "but the real quality of the formulas hasn't been properly checked and, to"
LOCATE 15, 4: PRINT "my knowledge, no Mosby Null gratings have actually been made and tested"
LOCATE 16, 4: PRINT "against reality to verify that the formulas produce a valid Mosby Null"
LOCATE 17, 4: PRINT "grating.  Therefor, please understand that this program may or maynot"
LOCATE 18, 4: PRINT "actaully produce what it claims to be and you should use it in that light."
LOCATE 19, 4: PRINT "If you find any problems with this version of the program please let me know"
LOCATE 20, 4: PRINT "at  bobmay@nethere.com  as soon as possible and I'll try to get back to you"
LOCATE 21, 4: PRINT "ASAP at any date probably prior to 2003.  After that date, anything may be"
LOCATE 22, 4: PRINT "possible."
LOCATE 23, 4: PRINT
LOCATE 24, 4: PRINT
LOCATE 25, 4: PRINT
LOCATE 26, 4: PRINT "Press C to redisplay the image or Q to quit."
LOCATE 27, 4: PRINT
LOCATE 28, 4: PRINT

END SUB

SUB printmenu
  LOCATE 18, 2: PRINT "Press"
  LOCATE 19, 2: PRINT "C  calculate"
  LOCATE 20, 2: PRINT "B  make BMP"
  LOCATE 21, 2: PRINT "H  for help"
  LOCATE 22, 2: PRINT "N  for notes"
  LOCATE 23, 2: PRINT "R  restart"
  LOCATE 24, 2: PRINT "S  save parameters"
  LOCATE 25, 2: PRINT "Q  quit program "
END SUB

SUB printparams

LOCATE 3, 2: PRINT "Paraxial focus to grating ="; dr
LOCATE 2, 2: PRINT "The actual grating diameter ="; INT(100 * SQR(r2max)) / 100
LOCATE 4, 2: PRINT "Mirror Diameter ="; d
LOCATE 5, 2: PRINT "Focal Ratio ="; fr
LOCATE 7, 3: PRINT "Dimensions are as"
LOCATE 8, 3: PRINT "specified when"
LOCATE 9, 3: PRINT "entering data."
END SUB

